# generated by datamodel-codegen:
#   filename:  data_room.json

from __future__ import annotations

from typing import Optional, Sequence, Union

from typing_extensions import Literal, NotRequired, TypedDict


class AudienceReference7(TypedDict):
    kind: Literal['BASE']


class AudienceReference8(TypedDict):
    id: str
    kind: Literal['CUSTOM']


class AudienceReference9(TypedDict):
    audienceType: str
    kind: Literal['SEED']


AudienceReference = Union[AudienceReference7, AudienceReference8, AudienceReference9]


BooleanOp = Literal['AND', 'OR']


CombineOperator = Literal['INTERSECT', 'UNION', 'DIFF']


class CustomAudienceDefinition5(TypedDict):
    excludeSeedAudience: NotRequired[Optional[bool]]
    kind: Literal['LOOKALIKE']
    reach: int
    sourceRef: AudienceReference


Features = Literal[
    'ENABLE_DEBUG_MODE',
    'ENABLE_INSIGHTS',
    'ENABLE_REMARKETING',
    'ENABLE_LOOKALIKE_AUDIENCES',
    'ENABLE_RULED_BASED_AUDIENCES',
    'ENABLE_HIDE_ABSOLUTE_AUDIENCE_SIZES',
]


FilterOperator = Literal[
    'CONTAINS_ANY_OF', 'CONTAINS_NONE_OF', 'CONTAINS_ALL_OF', 'EMPTY', 'NOT_EMPTY'
]


FormatType = Literal[
    'STRING',
    'INTEGER',
    'FLOAT',
    'EMAIL',
    'DATE_ISO8601',
    'PHONE_NUMBER_E164',
    'HASH_SHA256_HEX',
]


HashingAlgorithm = Literal['SHA256_HEX']


ModelEvaluationType = Literal['ROC_CURVE', 'DISTANCE_TO_EMBEDDING', 'JACCARD']


Permission = Literal[
    'VIEW_OVERLAP',
    'VIEW_INSIGHTS',
    'PROVIDE_SEED_AUDIENCE',
    'PROVIDE_BASE_AUDIENCE',
    'CREATE_CUSTOM_AUDIENCE',
    'EXPORT_AUDIENCE',
    'MODEL_QUALITY',
]


class PublishedPolicy(TypedDict):
    leafId: str
    policyId: str
    publishedAt: NotRequired[Optional[str]]
    publishedByEmail: NotRequired[Optional[str]]


class AudienceFilter(TypedDict):
    attribute: str
    operator: FilterOperator
    values: NotRequired[Sequence[str]]


class AudienceFilters(TypedDict):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class ModelEvaluationConfig(TypedDict):
    postScopeMerge: Sequence[ModelEvaluationType]
    preScopeMerge: Sequence[ModelEvaluationType]


class ParticipantGroup(TypedDict):
    emails: Sequence[str]
    id: str
    organizationId: NotRequired[Optional[str]]
    permissions: Sequence[Permission]
    role: str


class AudienceCombinator(TypedDict):
    filters: NotRequired[Optional[AudienceFilters]]
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition6(TypedDict):
    combine: NotRequired[Sequence[AudienceCombinator]]
    filters: NotRequired[Optional[AudienceFilters]]
    kind: Literal['RULE_BASED']
    sourceRef: AudienceReference


CustomAudienceDefinition = Union[CustomAudienceDefinition5, CustomAudienceDefinition6]


class CustomAudience(TypedDict):
    createdAt: str
    createdBy: str
    definition: CustomAudienceDefinition
    id: str
    name: str
    sharedWith: NotRequired[Sequence[str]]


class DataRoom1(TypedDict):
    kind: Literal['media']
    customAudiences: Sequence[CustomAudience]
    features: Sequence[Features]
    hashMatchingIdWith: NotRequired[Optional[HashingAlgorithm]]
    matchingIdFormat: FormatType
    modelEvaluation: NotRequired[Optional[ModelEvaluationConfig]]
    name: str
    participantGroups: Sequence[ParticipantGroup]
    policies: Sequence[PublishedPolicy]
    version: Literal['v0']


DataRoom = DataRoom1
